/*
	File : backproj.c
*/

/* --- vO̐ ---

te֐

֐F
void BackProjection(int pp, float *buff, int nx, int ny, float *para, int px, int pa)
  int    pp;     // ef[^΂܂2΂̃f[^ɂāC"1""2"w肷
  float  *buff;  // teč쐬摜f[^
  int    nx;     // 摜f[^x̉f
  int    ny;     // 摜f[^ỷf
  float  *buff;  // te铊ef[^
  int    nx;     // ef[^̓ãf[^
  int    ny;     // ef[^̊px̃f[^

*/

#include        <math.h>

#define  PI  3.14159265358979

void BackProjection(int pp, float *buff, int nx, int ny, float *para, int px, int pa)
{
	int     i,j,k,ix;
	float	*bp2;
	double  x0,cx,cy,th,tx,ty,t1,t2;

	for(i = 0 ; i < nx*ny ; i++)
		buff[i] = 0;
	for(k = 0 ; k < pa ; k++) {
		th = pp*k*PI/pa;
		cx = cos(th);
		cy = -sin(th);
		x0 = -cx*nx/2-cy*ny/2+px/2;
		bp2 = para+k*px;
		for(i = 0, ty = x0 ; i < ny ; i++, ty += cy) {
			for(j = 0, tx = ty ; j < nx ; j++, tx += cx) {
				ix = (int)tx;
				t1 = tx-ix; t2 = 1-t1;
				if(ix < 0 || ix > px-2)       continue;
				buff[i*nx+j] += (float)(bp2[ix+1]*t1+bp2[ix]*t2);
			}
		}
	}
	for(i = 0 ; i < nx*ny ; i++)
		buff[i] /= pa;
}
